const { Telegraf } = require('telegraf');
const covidApi = require('covid19-api');
const COUNTRIES_LIST = require('./const')
const {TOKEN,PORT,REC_PATH} = require('./config')
const {LOGO1,LOGO2} = require('./config')
const glob = require('glob')
const fs  = require('fs')
const nodeCmd = require('node-cmd')
const path = require('path')
//const request = require('request')
//const https = require('https'); 
const sleep = require('await-sleep')
//const Axios = require('axios')
//const FormData = require('form-data')

var rsp

const {getBx24Menu,getMainMenu, getStartMenu, getRecMenu, yesNoKeyboard, aaa } = require('./keyboards.js')
const {sp} = require('./decod51.js')
const { getMyTasks, addTask, deleteTask, showTask, clearTasks, countTasks } = require('./db.js')


const bot = new Telegraf(TOKEN)



bot.start( ctx => { 
        let at = aaa(ctx)
        console.log(ctx.from.id.toString()+'_'+ctx.from.first_name+'_'+ctx.from.username )
        if(at != 0){ ctx.reply(ctx.message.text); return; }

//Получить весь список стран можно по команде /help.
//Ваш id ${ctx.from.id}
ctx.replyWithHTML(`
    Привет ${ctx.from.first_name}! 
    Вот список команд, которые я выполню  :
    /start
    /covid
    /records
    /bitrix24
`,getStartMenu())

//ctx.replyWithHTML(getStartMenu())
}
)
////////////////////Command
bot.command('covid',(ctx)=>{
//console.log('*************',ctx)
//Ваш id ${ctx.from.id}
ctx.replyWithHTML(`
    Привет ${ctx.from.first_name}! 
    Узнай статистику по Коронавирусу. 
    Введи страну russia на английском языке и получи статистику.
    Получить весь список стран можно по команде /help
`)
})
bot.command('records',(ctx)=>{
//Ваш id ${ctx.from.id}
ctx.replyWithHTML(`
    Привет ${ctx.from.first_name}! 
    Приветсвую в TaskManagerBot
    Для поиска файла напишите год месяц число час мин в формате:

    например:
                           YYYYMMDDHH
                           2021010112
                            
                                или
                                          
                           YYYYMMDDHHmm
                           202101011245       
            
                         и отправьте >> боту

`,getRecMenu())
})

bot.command('bitrix24',(ctx)=>{
//Ваш id ${ctx.from.id}
ctx.replyWithHTML(`
    Привет ${ctx.from.first_name}! 
    Я могу выключить битрикс 
    или отключить битрикс
    и даже показать статус битрикса
    также доступны голосовые команды
`,getBx24Menu())
})

////////////////////
bot.help( ctx =>
{

let at = aaa(ctx)
     if(at != 0){ ctx.reply(ctx.message.text); return; }

 ctx.reply(COUNTRIES_LIST) // список всех стран на английском языке можно взять в документации covid19-api

}
)

bot.hears('Мои файлы', async ctx => {

let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
    const tasks = await getMyTasks()
    let result = ''
    console.log("LENGHT TASK = " + tasks.length)
let j=0
    for (let i = 0; i < tasks.length; i++) {
      
        result = result + `[${i+1}] ${path.basename(tasks[i])}\n`
        j++
        if(j==45){ 
    ctx.replyWithHTML('<b>Список ваших файлов:</b>\n\n'+`${result}`)    
        result = ''
        j=0
               }

    }
    ctx.replyWithHTML(
        '<b>Список ваших файлов:</b>\n\n'+
        `${result}`
    )


})

bot.hears('Скачать файл', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
    ctx.replyWithHTML(
        'Введите фразу <i>"скачать `порядковый номер файла`"</i>, чтобы скачать файл,'+
        'например, <b>"скачать 3"</b>:'
    )
})


bot.hears(/^скачать\s(\d+)$|^Скачать\s(\d+)/, ctx => {
console.log('listTasks=',countTasks())
if(countTasks()==0){ctx.reply('Список файлов пуст'); return;}
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }

    const id = Number(+/\d+/.exec(ctx.message.text)) - 1

    let  str =  showTask(id)
    let  strbsn =path.basename(str)
    let  outstr = strbsn.split('.')
    ctx.replyWithVoice({source:str},{caption: path.basename(str)})
    ctx.reply('Ваша задача будет успешно выполнена')
})

/*
bot.hears(/^Скачать\s(\d+)$/, ctx => {
//bot.hears(/^скачать\s(\d+)$/, ctx => {
console.log('listTasks=',countTasks())
if(countTasks()==0){ctx.reply('Список файлов пуст'); return }
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }

    const id = Number(+/\d+/.exec(ctx.message.text)) - 1

    let  str =  showTask(id)
    let  strbsn =path.basename(str)
    let  outstr = strbsn.split('.')
    ctx.replyWithVoice({source:str},{caption: path.basename(str)})
    ctx.reply('Ваша задача будет успешно выполнена')
})
*/




bot.hears('Очистить поиск', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }

    clearTasks()
    ctx.replyWithPhoto(  
LOGO2,
        {
            caption: 'Buick Riviera'
        }
    )
})

bot.hears('Смотивируй меня', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
    ctx.replyWithPhoto( 
LOGO2,
        {
            caption: 'Buick Riviera'
        }
    )
})

bot.hears('Мои команды', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
ctx.replyWithHTML(`
    Привет ${ctx.from.first_name}! 
    Вот список команд, которые я выполню  :
    /start
    /covid
    /records
    /bitrix24
`,getStartMenu())
})

bot.hears('Битрикс Вкл', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
nodeCmd.get('./ON_OFF_BX24/on_bx24/on_bx24.sh',(err,data,stderr) => {
if(err) {console.log('ON_bx24 Error',err);return;}
ctx.reply('Включен')
})
})


bot.hears('Битрикс Выкл', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
nodeCmd.get('./ON_OFF_BX24/off_bx24/off_bx24.sh',(err,data,stderr) => {
if(err) {console.log('OFF_bx24 Error',err);return;}
ctx.reply('Выключен')
}) ;
//console.log('Status: ',st) 
})


bot.hears('Статус Битрикс', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
let st
nodeCmd.get('./ON_OFF_BX24/status_bx24/status_bx24.sh',(err,data,stderr) => 
{
if(data.length===0){ctx.reply('Выключен')}
else{ctx.reply('Включен')}
})
})

bot.hears('Бьюик', ctx => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
    ctx.replyWithPhoto( 
LOGO1,
        {
            caption: 'Buick Riviera'
        }
    )
})

///////////////////////

bot.on('voice',  (ctx) => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }

//let file_path =''
let url = 'https://api.telegram.org/bot' + TOKEN + '/getFile?file_id=' + ctx.message.voice.file_id
sp(ctx)
//console.log('Return from promise: ',r)


//	console.log(ctx.message.voice.file_id)
	//console.log(ctx.voice.file_id)

	
})


bot.on('video',  (ctx) => {


//let file_path =''
let url = 'https://api.telegram.org/bot' + TOKEN + '/getFile?file_id=' + ctx.message.voice.file_id
//	    console.log(url);
let r = downloadVoiceFile(ctx)


	
})
        
		
		
bot.on('text', async (ctx) => {
let at = aaa(ctx)
if(at != 0){ ctx.reply(ctx.message.text); return; }
/////////////////////////////////////
let ts =  /^[\d\-\/]*$/.test(ctx.message.text)
console.log(ctx.message.text  + '=== ' + ts )
if(ts===true ){
console.log(ctx.message.text.length)
if(ctx.message.text.length < 10 ){ 
ctx.reply('Задайте параметр поиска больше 9-ти цифр'+'\n'
+ 'год 4 цифры'+'\n'
+  'месяц 2 цифры'+'\n'
+  'день 2 цифры  '+'\n'
+  'час  2 цифры'+'\n'
+  'например 2021020409'+'\n'
+  'Это значит - 2021 год, февраль месяц, 4 число,  на 9 часов утра'
 ) ; 
//{callback_data"records"}
return   }
clearTasks();
glob(REC_PATH + ctx.message.text +'*.*', {}, (err,files)=>{
 if(err) {/*console.log("ERROR= "+err)*/ throw err }
 files.forEach(el => {
                addTask(el)
        //      ctx.replyWithVoice({source:el},{caption: path.basename(el) })
                                         })
                    });

ctx.reply('Нажмите кнопку Мои файлы') ;

}
else{
//////////////////////////////////////


//console.log("TEST TEST")
    try {
    
switch(ctx.message.text ){

case 'core': nodeCmd.get('asterisk -rx "core show calls"',(err,data,stderr) => ctx.reply(data)) ; break;

//case 'menu': ctx.reply(ctx.from.id,'Выберите любую кнопку:', options) ;break;


//case 'russia':break;

default: 

//        console.log(ctx.message.text)
    //    ctx.replyWithPhoto(img)
        const userText = ctx.message.text
        const covidData = await covidApi.getReportsByCountries(userText)
        const countryData = covidData[0][0]
        const img = countryData.flag
        const formatData = `
            Страна: ${countryData.country},
            Случаи: ${countryData.cases},
            Смерти: ${countryData.deaths},
            Выздоровело: ${countryData.recovered}
             `
    //    console.log(countryData)
    //      Флаг:   ${countryData.flag},
        ctx.reply(formatData) 
        ctx.replyWithPhoto(img)

break;

}
    } catch(e) {
        ctx.reply('Такой страны не существует, для получения списка стран используй команду /help')
    }

}
/////////////////////
})



bot.launch()





